Bug 833481 - gperftools heap profile fails with "Hooked allocator frame not found, returning empty trace"
gperftools heap profile fails with "Hooked allocator frame not found, returni...
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: gperftools (Show other bugs)
17
i386 Linux
unspecified Severity medium
: ---
: ---
Assigned To: Tom "spot" Callaway
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-06-19 10:45 EDT by michael.barton10
Modified: 2013-08-01 07:30 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-08-01 07:30:44 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description michael.barton10 2012-06-19 10:45:17 EDT
Description of problem:
When using the heap profiler in gperftools, the error

"Hooked allocator frame not found, returning empty trace"

is repeatedly emitted.

Version-Release number of selected component (if applicable):
gperftools 2.0 (from Fedora 17 repo)

How reproducible:
Reproducible

Steps to Reproduce:
1. LD_PRELOAD in libtcmalloc.so
2. Set HEAPPROFILE environment variable as per http://goog-perftools.sourceforge.net/doc/heap_profiler.html
3. Run a program of your choice
  
Actual results:
The error "Hooked allocator frame not found, returning empty trace" is repeatedly emitted.

Expected results:
Message is emitted indicating that heap profiling is occurring and profiles are written.

Additional info:
I believe this is because GCC 4.6 switched to omit frame pointers by default (see -fomit-frame-pointer here http://gcc.gnu.org/onlinedocs/gcc/Optimize-Options.html). As such, libtcmalloc was compiled without frame pointers. Ironically, the built in heap profiler requires frame pointers or it will emit the error above on every malloc. As such even if you were profiling a program with frame pointers (as I was) perftools will trip up over itself.

I fixed this by manually building perftools with the alteration from r150 in the gperftools repository (https://code.google.com/p/gperftools/source/detail?r=150, basically adding -fno-omit-frame-pointer to compile tcmalloc with frame pointers). So I guess the way to fix this is to either change the repo here to track the head of gperftools or wait for the next release as they mention the fix will be included (see last comment here https://code.google.com/p/gperftools/issues/detail?can=2&q=385&colspec=ID%20Type%20Status%20Priority%20Milestone%20Owner%20Summary&id=385)
Comment 1 Fedora End Of Life 2013-07-03 23:38:32 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 2 Fedora End Of Life 2013-08-01 07:30:48 EDT
Fedora 17 changed to end-of-life (EOL) status on 2013-07-30. Fedora 17 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.